# Bulk Create Attestations

For certain use cases, issuers may want to create Zttestations in bulk to save on transaction fees.

The `AbstractPortal` contract that every Portal inherits from defines the following function:

```solidity
function bulkAttest(
  AttestationPayload[] memory attestationsPayloads,
  bytes[][] memory validationPayloads
) public payable;
```

This function is like the normal `attest` function but with a couple of differences. First, it takes an array of `AttestationPayload` structs as the first parameter, each one corresponding to a single Attestation. Second, it takes a two-dimensional array of `validationPayloads` in the second parameter. The first dimension of the array is a validation payload for each respective Attestation payload, the second dimension is the validation payload for each module in the module chain, to verify the respective Attestation.

{% hint style="danger" %}
This method may have unexpected behavior if one of the checks is done on the Attestation ID, as this ID won't be incremented before the end of the transaction. If you need to check the attestation ID, please use the \`attest\` method.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ver.ax/verax-documentation/developer-guides/for-attestation-issuers/bulk-create-attestations.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
